/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package tekenaar;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Random;
import java.util.Scanner;
import java.util.Set;
import java.util.TreeSet;
import javax.swing.ImageIcon;

/**
 *
 * @author Leen
 */
public class TekenFabriek {

    private HashMap<String, TreeSet<String>> afbeeldingenVanCategorie;

    public TekenFabriek(String bestandsnaam) throws FileNotFoundException {
        afbeeldingenVanCategorie = new HashMap<>();

        Scanner sc = new Scanner(new File(bestandsnaam));

        while (sc.hasNext()) {
            Scanner sc2 = new Scanner(sc.nextLine());
            sc2.useDelimiter(";");
            String categorie = sc2.next().trim();
            String afbeelding = sc2.next().trim();
            if (!afbeeldingenVanCategorie.containsKey(categorie)) {
                afbeeldingenVanCategorie.put(categorie, new TreeSet<String>());
            }
            afbeeldingenVanCategorie.get(categorie).add(afbeelding);
        }
    }

    public List<String> geefVerschillendeCategorieen(int aantal) throws NotEnoughCategoriesFoundException {
        if (aantal > afbeeldingenVanCategorie.keySet().size()) {
            String s = "Je vroeg " + aantal + " categorieen; er zijn er maar ";
            s += afbeeldingenVanCategorie.keySet().size();
            throw new NotEnoughCategoriesFoundException(s);
        }
        // eerst omzetten naar list, omdat je dan met randomindex een element kan kiezen
        List<String> opsommingOmUitTeKiezen = new ArrayList(afbeeldingenVanCategorie.keySet());
        Random random = new Random();
        Set<String> verz = new TreeSet<>();
        while (verz.size() != aantal) {
            verz.add(opsommingOmUitTeKiezen.get(random.nextInt(opsommingOmUitTeKiezen.size())));
        }
        return new ArrayList(verz);

    }

    public Set<String> geefOpsommingVan(String categorie) {
        return afbeeldingenVanCategorie.get(categorie);
    }

    public ImageIcon geefAfbeeldingVan(String naam) {
        return new ImageIcon(naam + ".jpg");
    }
}
